﻿<?php
/**
 *	Title:			strongauth.php
 *  Date:			04/06/2014
 * 	Author:			johnny33
 *	Description:	Provides the admin with a strong authentication mechanism
 */
 
session_start();

if ((isset($_GET['auth'])) and (isset($_GET['captcha'])) and (!empty($_SESSION['captcha'])))
{

	// Get the microtime to initialize the generator
	$t = microtime(true);
	$t = floor($t * 10);
	srand($t);

	// Allowed characters
	$chars = array_merge(range('A', 'Z'), range('a', 'z'), range('0', '9'));
	
	$authenticator = "";
	$nb = rand(5, 10);
	
	for($i = 0; $i < $nb; $i++)
	{
		$authenticator .= $chars[rand(0, count($chars)-1)];		// Only writable characters !
	}

	// Success
	if (($_GET['auth'] == $authenticator) and ($_GET['captcha'] == $_SESSION['captcha']))
	{
		$_SESSION['web5'] = true;
		header('Location: success.php');
		echo "<a href='success.php'>Cliquez ici si votre navigateur ne vous redirige pas automatiquement.</a>";
	}
}
?>

<!DOCTYPE HTML>
<html lang="fr-FR">
	<head>
		<title>Web 5</title>
		<meta charset="utf-8">
		<link rel="stylesheet" href="../style.css">
	</head>

	<body>
		<div id="background">
			<h1>Web 5</h1>
		
			<form action="" method="get" id="strongauth_form">
				<fieldset>
					<legend>Authentification forte</legend>
					
					<label for="auth" id="auth_lbl">Code d'authentification :</label>
						<input type="text" name="auth" id="auth_in" /><br />
					
					<label for="captcha" id="captcha_lbl"><img src="captcha.php" id="captcha" alt="captcha" title="Merci de recopier le texte joint" /></label>
						<input type="text" name="captcha" id="captcha_in" /><br />
						
					<input type="submit" value="Authentification" />
				</fieldset>
			</form>
			
			<p class="info">
				Ce challenge mettra à l'épreuve les compétences Web de l'attaquant en lui proposant de découvrir et d'exploiter une faille Web.
				A l'issue de ce défi, l'attaquant obtiendra une connaissance approfondie de différents générateurs de nombres pseudo-aléatoires
				ainsi que de leur fonctionnement et sera à-même de contourner une image captcha.
			</p>
			
			<p class="info">
				Etant très attaché à la sécurité de son site Web, l'administrateur a installé deux sécurités dans le but de fournir une
				authentification forte. En effet, un formulaire requiert l'insertion d'un code d'authentification ; il s'agit d'un mot de passe variable 
				dans le temps et que l'administrateur est lui seul capable de générer grâce à un utilitaire de sa création. Enfin, pour éviter que des 
				pirates n'effectuent une attaque par force brute sur ce code, le propriétaire du site y a inclus un captcha, une image au contenu variable
				que seul l'oeil humain peut déchiffrer.
			</p>
			
			<p class="info">
				Vous trouverez les fichiers nécessaires à la résolution de ce challenge <a href="web5.zip">ici.<a/>
			</p>
		</div>
	</body>
</html>
